/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ShapeSeriesBase } from "./ShapeSeriesBase";
import { ShapeAxisInfoCache } from "./ShapeAxisInfoCache";
import { StyleSelector } from "./StyleSelector";
import { DependencyProperty } from "igniteui-react-core";
import { Style } from "igniteui-react-core";
import { MarkerType_$type } from "./MarkerType";
import { DataTemplate } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { CollisionAvoidanceType_$type } from "./CollisionAvoidanceType";
import { MarkerOutlineMode_$type } from "./MarkerOutlineMode";
import { MarkerFillMode_$type } from "./MarkerFillMode";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { Base, runOn, enumGetBox, Number_$type, typeCast, fromEnum, markType, markDep, PointUtil } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { OwnedPoint } from "./OwnedPoint";
import { ShapeSeriesViewBase } from "./ShapeSeriesViewBase";
import { Marker } from "./Marker";
import { MarkerSeries } from "./MarkerSeries";
import { BrushUtil } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { HashPool$2 } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { RectUtil } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { isNaN_, isInfinity } from "igniteui-react-core";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { DataTemplateMeasureInfo } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { Defaults } from "./Defaults";
import { DataTemplatePassInfo } from "igniteui-react-core";
import { DataTemplateRenderInfo } from "igniteui-react-core";
import { MarkerVisualData } from "./MarkerVisualData";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
export let ScatterPolygonSeries = /*@__PURE__*/ (() => {
    class ScatterPolygonSeries extends ShapeSeriesBase {
        bi() {
            return new ScatterPolygonSeries();
        }
        get_fo() {
            return true;
        }
        get_fj() {
            return true;
        }
        constructor() {
            super();
            this.zu = null;
            this.zr = new ScalerParams(1, ScatterPolygonSeries.aa0, ScatterPolygonSeries.aa0, false);
            this.zs = new ScalerParams(1, ScatterPolygonSeries.aa0, ScatterPolygonSeries.aa0, false);
            this.aag = null;
            this.zm = 1;
            this.zi = 1;
            this.ab = ScatterPolygonSeries.$;
        }
        xx() {
            return this.zw();
        }
        yz(a) {
            let b = a;
            b.cy(this.aa2);
            b.cz(this.zv);
            super.yz(a);
            if (this.d3(a)) {
                return;
            }
            let c, d;
            let e = a.getViewInfo(c, d);
            c = e.p0;
            d = e.p1;
            let f = this.getEffectiveViewport1(a);
            this.zr = new ScalerParams(1, d, c, this.w1.ch);
            this.zr.c = f;
            this.zs = new ScalerParams(1, d, c, this.w3.ch);
            this.zs.c = f;
            if (c.width < 1 || c.height < 1) {
                return;
            }
            this.zu = ((() => {
                let $ret = new ShapeAxisInfoCache();
                $ret.a = this.w1;
                $ret.b = this.w3;
                $ret.e = this.w1.ch;
                $ret.f = this.w3.ch;
                $ret.d = this.dl;
                $ret.c = this.xg;
                return $ret;
            })());
            if (this.zw()) {
                let g = new Dictionary$2(Base.$, OwnedPoint.$, 0);
                b.dg.l(g, 400, d, c, this.ib);
                b.dg.j(g, false);
                if (this.xv()) {
                    this.aad(a);
                }
            }
        }
        aad(a) {
            a.dk = true;
            this.w8.ay(this, this.xv(), runOn(this, this.wv));
            let b = this.w8.d;
            let c = b != null;
            let d = this.getEffectiveViewport1(a);
            let e = this.dl == null ? 0 : this.dl.count;
            a.dw((f) => {
                if (f._visibility == 0) {
                    let g = f.ak;
                    let h = f.content;
                    if (h == null) {
                        h = new DataContext();
                        f.content = h;
                    }
                    if (c) {
                        this.yu(g, e, a.q);
                    }
                    this.w8.ac(f, h);
                }
            });
        }
        zw() {
            return this.aag != null && ((this.zq != 1 && this.zq != 0) || this.aah != null);
        }
        cq() {
            return new ScatterPolygonSeriesView(this);
        }
        qw(a) {
            super.qw(a);
            this.zt = a;
        }
        get_hasMarkers() {
            return true;
        }
        get_ej() {
            return this.zq != 13 && this.zq != 1;
        }
        ve() {
            return this.aaw;
        }
        vf() {
            return this.aax;
        }
        ss() {
            return this.aaf;
        }
        l7() {
            return this.l8(this, this.aag);
        }
        il() {
            return this.zy;
        }
        get zn() {
            return this.zm;
        }
        set zn(a) {
            this.zm = a;
        }
        zp() {
            if (this.zo == 0) {
                return 1;
            }
            return this.zo;
        }
        se(a) {
            super.se(a);
            this.zo = a;
        }
        get zj() {
            return this.zi;
        }
        set zj(a) {
            this.zi = a;
        }
        zl() {
            if (this.zk == 0) {
                return 2;
            }
            return this.zk;
        }
        sd(a) {
            super.sd(a);
            this.zk = a;
        }
        sf(a) {
            super.sf(a);
            this.zy = a;
        }
        sa() {
            super.sa();
            if (this.index < 0) {
                return;
            }
            if (this.aah != null) {
                this.zt.dv();
                this.zt.ds();
            }
            else {
                let a = MarkerSeries.w2(this, this.zq);
                let b = MarkerSeries.xf(a);
                if (b == null) {
                    this.aaf = MarkerSeries.xu;
                }
                else {
                    this.zt.dp(b);
                }
            }
            if (this.aay != null && this.zq != 13) {
                this.r1("ActualMarkerBrush");
                let c = this.aaw;
                this.zt.dt();
                this.zt.dq();
                let d = this.aaw;
                let e = this.ff("ActualMarkerBrush", this.ht.f > 0 ? this.ht.d() : null, c, d);
                this.r3("ActualMarkerBrush", e);
            }
            else {
                if (this.zq == 13) {
                    this.aaw = this.ct.bt();
                }
                else {
                    if (this.zj != 2) {
                        if (this.c9 != null) {
                            let f = this.c9.uv(this.index);
                            if (!isNaN_(this.ia) && this.ia != 1) {
                                f = BrushUtil.q(f, this.ia);
                            }
                            this.aaw = f;
                        }
                        else {
                            this.aaw = null;
                        }
                    }
                }
            }
            if (this.aaz != null) {
                this.zt.du();
                this.zt.dr();
            }
            else {
                if (this.zq == 13) {
                    this.aax = this.ct.bt();
                }
                else {
                    if (this.zo == 2) {
                        this.aax = this.aaw;
                    }
                    else {
                        this.aax = this.c9 == null ? null : this.c9.uw(this.index);
                    }
                }
            }
            if (this.zj == 2 && this.aay == null && this.zq != 13) {
                if (this.aax != null) {
                    let g = this.aax;
                    if (!isNaN_(this.ia) && this.ia != 1) {
                        g = BrushUtil.q(g, this.ia);
                    }
                    this.aaw = g;
                }
                else {
                    this.aaw = null;
                }
            }
        }
        qn() {
            super.qn();
            this.zn = this.zp();
            this.zj = this.zl();
        }
        q4(a, b, c, d) {
            super.q4(a, b, c, d);
            switch (b) {
                case ScatterPolygonSeries.$$p[3]:
                case ScatterPolygonSeries.$$p[11]:
                case ScatterPolygonSeries.$$p[7]:
                case ScatterPolygonSeries.$$p[9]:
                case ScatterPolygonSeries.$$p[10]:
                    this.ra(b);
                    this.qy();
                    break;
                case ScatterPolygonSeries.$$p[6]:
                    this.zn = this.zp();
                    this.ra(null);
                    this.qy();
                    break;
                case ScatterPolygonSeries.$$p[5]:
                    this.zj = this.zl();
                    this.ra(null);
                    this.qy();
                    break;
                case ScatterPolygonSeries.$$p[2]:
                    this.aag = d;
                    if (c == MarkerSeries.xu || d == MarkerSeries.xu || (c == null || d != null)) {
                        this.zt.dx();
                        this.rm(false);
                    }
                    this.ct.bl();
                    if (this.toolTip != null && this.fg) {
                        this.a9.a$as(this, this.toolTip);
                    }
                    this.rm(false);
                    this.qg();
                    break;
                case ScatterPolygonSeries.$$p[12]:
                    this.zt.cy(this.aa2);
                    this.rm(false);
                    this.qg();
                    break;
                case ScatterPolygonSeries.$$p[13]:
                    this.zt.cz(this.zv);
                    this.rm(false);
                    this.qg();
                    break;
                case ScatterPolygonSeries.$$p[4]:
                    this.rm(false);
                    this.qg();
                    break;
                case ScatterPolygonSeries.$$p[0]:
                case ScatterPolygonSeries.$$p[1]:
                    if (this.zw()) {
                        this.rm(false);
                    }
                    break;
            }
        }
        a1(a, b) {
            let c = this.zt.b4(a);
            let d = null;
            if (c != null) {
                d = c.content;
            }
            if (d != null) {
                return d;
            }
            return super.a1(a, b);
        }
        aae(a, b) {
            let c = new List$1(Base.$, 0);
            for (let d of fromEnum(b.c)) {
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
            for (let e of fromEnum(c)) {
                b.h(e);
            }
        }
        d9(a, b, c, d) {
            if (!this.hasMarkers) {
                return false;
            }
            let e = this.w1;
            let f = new ScalerParams(1, this.c9.vl, this.wk, e.ch);
            f.c = this.getEffectiveViewport1(this.ct);
            let g = this.w3;
            let h = new ScalerParams(1, this.c9.vl, this.wk, g.ch);
            h.c = this.getEffectiveViewport1(this.ct);
            a.clear();
            this.zt.dw((i) => {
                if (i._visibility == 0) {
                    let j = new SeriesPointOfInterest();
                    let k = i.n;
                    let l = i.o;
                    if (k < this.wk.left || k > this.wk.right || l < this.wk.top || l > this.wk.bottom) {
                        return;
                    }
                    j.d = e.en(k, f);
                    j.e = g.en(l, h);
                    j.b = i.content;
                    j.g = this.u9;
                    j.c = i.ak;
                    if (this.g7) {
                        j.g = this.vg(i.ak);
                    }
                    a.add(j);
                }
            });
            return true;
        }
        zg(a, b, c, d, e) {
            if (c == null || c.length != this.zu.d.count) {
                c = new Array(this.zu.d.count);
                for (let f = 0; f < this.zu.d.count; f++) {
                    c[f] = PointUtil.create();
                }
            }
            let g = ((() => {
                let $ret = new ScalerParams(1, d, e, this.w1.ch);
                $ret.c = this.getEffectiveViewport1(a);
                return $ret;
            })());
            let h = ((() => {
                let $ret = new ScalerParams(1, d, e, this.w3.ch);
                $ret.c = this.getEffectiveViewport1(a);
                return $ret;
            })());
            let i = this.wc(a);
            let j = this.zu.a.en(i.left, g);
            let k = this.zu.a.en(i.right, g);
            let l = this.zu.b.en(i.bottom, h);
            let m = this.zu.b.en(i.top, h);
            if (this.zu.e) {
                let n = j;
                j = k;
                k = n;
            }
            if (this.zu.f) {
                let o = l;
                l = m;
                m = o;
            }
            let p = this.zu;
            let q = p.a;
            let r = p.b;
            let s;
            let t;
            let u = g.d.left;
            let v = g.d.right;
            let w = h.d.top;
            let x = h.d.bottom;
            for (let y = 0; y < this.zu.d.count; y++) {
                s = 0;
                t = 0;
                let z = null;
                let aa = a.cc.tryGetValue(y, z);
                z = aa.p1;
                if (z == null) {
                    c[y].x = NaN;
                    c[y].y = NaN;
                }
                else {
                    let ab = z.c;
                    let ac = RectUtil.l(ab);
                    s = ac.x;
                    t = ac.y;
                    if (s >= u && s <= v && t >= w && t <= x) {
                        c[y].x = s;
                        c[y].y = t;
                    }
                    else {
                        c[y].x = NaN;
                        c[y].y = NaN;
                    }
                }
            }
            return c;
        }
        zx(a, b) {
            if (b == null) {
                b = new List$1(Number_$type, 2, a.e);
            }
            else {
                b.clear();
            }
            let c = 0;
            let d = this.dl;
            for (let e of fromEnum(a.c)) {
                b.add(d.indexOf(e));
                c++;
            }
            return b;
        }
    }
    ScatterPolygonSeries.$t = /*@__PURE__*/ markType(ScatterPolygonSeries, 'ScatterPolygonSeries', ShapeSeriesBase.$);
    ScatterPolygonSeries.aa0 = /*@__PURE__*/ new Rect(0, 0, 0, 1, 1);
    ScatterPolygonSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, ScatterPolygonSeries, 'raisePropertyChanged', ['ActualMarkerBrush:aaw:aai', [Brush.$], 'ActualMarkerOutline:aax:aaj', [Brush.$], 'ActualMarkerTemplate:aaf:aak', [DataTemplate.$, null], 'MarkerBrush:aay:aal', [Brush.$], 'MarkerCollisionAvoidance:zh:aam', [CollisionAvoidanceType_$type, /*@__PURE__*/ enumGetBox(CollisionAvoidanceType_$type, 0)], 'MarkerFillMode:zk:aan', [MarkerFillMode_$type, /*@__PURE__*/ enumGetBox(MarkerFillMode_$type, 0)], 'MarkerOutlineMode:zo:aao', [MarkerOutlineMode_$type, /*@__PURE__*/ enumGetBox(MarkerOutlineMode_$type, 0)], 'MarkerOutline:aaz:aap', [Brush.$], 'MarkerStyle:aa1:aaq', [Style.$], 'MarkerTemplate:aah:aar', [DataTemplate.$, null], 'MarkerThickness:zy:aas', [1, /*@__PURE__*/ DeviceUtils.g(2)], 'MarkerType:zq:aat', [MarkerType_$type, /*@__PURE__*/ enumGetBox(MarkerType_$type, 1)], 'ShapeStyle:aa2:aau', [Style.$, null], 'ShapeStyleSelector:zv:aav', [StyleSelector.$, null]]);
    return ScatterPolygonSeries;
})();
/**
 * @hidden
 */
export let ScatterPolygonSeriesView = /*@__PURE__*/ (() => {
    class ScatterPolygonSeriesView extends ShapeSeriesViewBase {
        constructor(a) {
            super(a);
            this.dk = false;
            this.db = null;
            this.dm = null;
            this.dh = null;
            this.df = null;
            this.dj = false;
            this.di = null;
            this.dn = null;
            this.dc = new Marker();
            this.d4 = null;
            this.dc = new Marker();
            this.dc.content = new DataContext();
            this.dh = a;
            this.di = new HashPool$2(Base.$, Marker.$);
            this.dn = new List$1(Marker.$, 0);
            this.dy(this.di);
            this.df = new NumericMarkerManager(1, (b) => this.di.item(b), (b) => this.dh.zu.d.item(b), runOn(this, this.d2), runOn(this, this.da), runOn(this, this.dl), () => this.dh.zh);
            this.df.q = runOn(this, this.d5);
        }
        au() {
            super.au();
            if (!this.q) {
                this.dh.aaz = Defaults.am;
                this.dh.jn = Defaults.z;
                this.dh.zy = Defaults.y;
                this.dh.zq = Defaults.f;
                this.dh.zk = Defaults.b;
            }
        }
        get dg() {
            return this.df;
        }
        d2(a) {
            this.dh.aae(a, this.di);
        }
        da() {
            this.db = this.dh.zg(this, this.di, this.db, this.by, this.bx);
            return this.db;
        }
        dl() {
            this.dm = this.dh.zx(this.di, this.dm);
            return this.dm;
        }
        c5(a, b) {
            return this.c6(a, b, true);
        }
        cm(a, b, c) {
            super.cm(a, b, c);
            ShapeSeriesViewBase.cl(this, a, b);
        }
        ck(a, b) {
            let c = a;
            if (c == null) {
                return;
            }
            c.an = b;
        }
        dw(a) {
            this.di.f(a);
        }
        dy(a) {
            a.create = runOn(this, this.de);
            a.destroy = runOn(this, this.d0);
            a.activate = runOn(this, this.dz);
            a.disactivate = runOn(this, this.d1);
        }
        de() {
            let a = new Marker();
            if (!this.dj) {
                a.content = ((() => {
                    let $ret = new DataContext();
                    $ret.series = this.e;
                    return $ret;
                })());
            }
            a.ah = this.e.aaf;
            this.dn.add(a);
            return a;
        }
        b4(a) {
            let b = this.dd(a, 0);
            if (b == null) {
                b = this.dd(a, 3);
            }
            return b;
        }
        dd(a, b) {
            let c;
            let d;
            let e;
            let f;
            for (let g = this.dn.count - 1; g >= 0; g--) {
                let h = this.dn._inner[g];
                if (h._visibility == 1 || h._opacity == 0) {
                    continue;
                }
                c = (h.m / 2) + b;
                d = (h.l / 2) + b;
                e = h.ai;
                f = h.aj;
                if ((h.n + e) - c <= a.x && (h.n + e) + c >= a.x && (h.o + f) - d <= a.y && (h.o + f) + d >= a.y) {
                    return h;
                }
            }
            return null;
        }
        d0(a) {
            a.content = null;
            this.dn.remove(a);
        }
        dz(a) {
            a._visibility = 0;
        }
        d1(a) {
            if (a.content != null) {
                (typeCast(DataContext.$, a.content)).item = null;
            }
            a._visibility = 1;
        }
        d3(a) {
            this.dj = a;
        }
        bj(a, b) {
            super.bj(a, b);
            if (!this.dk) {
                let c = a;
                let d = c.content;
                if (d != null) {
                    if (this.dh.aaw != null) {
                        d.actualItemBrush = this.dh.aaw;
                    }
                    else {
                        d.actualItemBrush = this.b6.u2;
                    }
                    if (this.dh.aaw != null) {
                        d.outline = this.dh.aax;
                    }
                    else {
                        d.outline = this.b6.u6;
                    }
                    d.thickness = this.dh.zy;
                }
            }
        }
        bk(a, b) {
            super.bk(a, b);
            let c = a;
            this.dc._visibility = c._visibility;
            this.dc.ah = c.ah;
            this.dc.width = c.width;
            this.dc.height = c.height;
            this.dc.m = c.m;
            this.dc.l = c.l;
            this.dc.n = c.n;
            this.dc.o = c.o;
            let d = this.bs(b);
            let e = this.dc.content;
            let f = c.content;
            e.item = f.item;
            e.series = f.series;
            e.thickness = f.thickness;
            if (e != null) {
                e.actualItemBrush = d;
                e.outline = d;
                e.thickness = this.dh.zy + 3;
            }
        }
        a7(a, b) {
            super.a7(a, b);
            let c = new DataTemplatePassInfo();
            c.isHitTestRender = b;
            c.context = a.h();
            c.viewportTop = this.bx.top;
            c.viewportLeft = this.bx.left;
            c.viewportWidth = this.bx.width;
            c.viewportHeight = this.bx.height;
            c.passID = "Markers";
            let d = new DataTemplateRenderInfo();
            d.passInfo = c;
            d.isHitTestRender = b;
            let e = new DataTemplateMeasureInfo();
            e.passInfo = c;
            let f = false;
            let g = a.h();
            e.context = g;
            d.context = g;
            let h = 0;
            let i = 0;
            if (this.dh.aaf != null && this.dh.aaf.passStarting != null) {
                this.dh.aaf.passStarting(c);
            }
            for (let j = 0; j < this.dn.count; j++) {
                let k = this.dn._inner[j];
                if (k._visibility == 1) {
                    continue;
                }
                this.bi(k, j, b);
                if (b) {
                    k = this.dc;
                }
                if (!f) {
                    e.width = k.width;
                    e.height = k.height;
                    e.renderOffsetX = 0;
                    e.renderOffsetY = 0;
                    e.renderContext = a;
                    let l = k.ah;
                    if (l.measure != null) {
                        e.data = k.content;
                        l.measure(e);
                        f = e.isConstant;
                        if (f) {
                            h = e.width;
                            i = e.height;
                        }
                    }
                    d.availableWidth = e.width;
                    d.availableHeight = e.height;
                    d.renderOffsetX = e.renderOffsetX;
                    d.renderOffsetY = e.renderOffsetY;
                    d.renderContext = a;
                }
                else {
                    d.availableWidth = h;
                    d.availableHeight = i;
                }
                if (!isNaN_(k.width) && !isInfinity(k.width)) {
                    d.availableWidth = k.width;
                }
                if (!isNaN_(k.height) && !isInfinity(k.height)) {
                    d.availableHeight = k.height;
                }
                a.q(d, k);
                k.m = d.availableWidth;
                k.l = d.availableHeight;
                k.ai = d.renderOffsetX;
                k.aj = d.renderOffsetY;
            }
            if (this.dh.aaf != null && this.dh.aaf.passCompleted != null) {
                this.dh.aaf.passCompleted(c);
            }
        }
        dv() {
            this.dh.aaf = null;
        }
        ds() {
            this.dh.aaf = null;
            this.dh.aaf = this.dh.aah;
        }
        dt() {
            this.dh.aaw = null;
        }
        dq() {
            this.dh.aaw = null;
            if (!isNaN_(this.e.ia) && this.e.ia != 1) {
                let a = BrushUtil.q(this.dh.aay, this.e.ia);
                this.dh.aaw = a;
            }
            else {
                this.dh.aaw = this.dh.aay;
            }
        }
        du() {
            this.dh.aax = null;
        }
        dr() {
            this.dh.aax = null;
            this.dh.aax = this.dh.aaz;
        }
        dp(a) {
            switch (a) {
                case "CircleMarkerTemplate":
                    this.dh.aaf = this.dh.c9.rn;
                    break;
                case "TriangleMarkerTemplate":
                    this.dh.aaf = this.dh.c9.rw;
                    break;
                case "PyramidMarkerTemplate":
                    this.dh.aaf = this.dh.c9.rt;
                    break;
                case "SquareMarkerTemplate":
                    this.dh.aaf = this.dh.c9.ru;
                    break;
                case "DiamondMarkerTemplate":
                    this.dh.aaf = this.dh.c9.ro;
                    break;
                case "PentagonMarkerTemplate":
                    this.dh.aaf = this.dh.c9.rr;
                    break;
                case "HexagonMarkerTemplate":
                    this.dh.aaf = this.dh.c9.rp;
                    break;
                case "TetragramMarkerTemplate":
                    this.dh.aaf = this.dh.c9.rr;
                    break;
                case "PentagramMarkerTemplate":
                    this.dh.aaf = this.dh.c9.rs;
                    break;
                case "HexagramMarkerTemplate":
                    this.dh.aaf = this.dh.c9.rq;
                    break;
            }
        }
        dx() {
            for (let a of fromEnum(this.dn)) {
                a.ah = this.dh.aaf;
            }
            this.as();
        }
        d5(a) {
            if (this.d4 == null) {
                this.d4 = new DataTemplateMeasureInfo();
                this.d4.context = this.k.h();
            }
            this.d4.width = a.width;
            this.d4.height = a.height;
            this.d4.data = a.content;
            let b = a.ah;
            if (b.measure != null) {
                b.measure(this.d4);
            }
            return new Size(1, this.d4.width, this.d4.height);
        }
        an(a) {
            let b = a;
            super.an(b);
            for (let c of fromEnum(this.di.c)) {
                let d = this.di.item(c);
                if (d._visibility != 1) {
                    let e = typeCast(ScatterPolygonSeries.$, this.e);
                    let f = this.e.bb.getMarkerVisualData(e, d, e.aaf);
                    b.markerShapes.add(typeCast(MarkerVisualData.$, f));
                }
            }
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.e.a9.a$u(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.dh.title + "</span><br/>";
            a += "</div>";
            return a;
        }
    }
    ScatterPolygonSeriesView.$t = /*@__PURE__*/ markType(ScatterPolygonSeriesView, 'ScatterPolygonSeriesView', ShapeSeriesViewBase.$);
    return ScatterPolygonSeriesView;
})();
